Attribute VB_Name = "Module1"
Sub Main()

   'Get CATIA or Launch it if necessary.
    On Error Resume Next
    Set MyCATIA = GetObject(, "CATIA.Application")
    If Err.Number <> 0 Then
        Set MyCATIA = CreateObject("CATIA.Application")
        MyCATIA.Visible = False
    End If
    On Error GoTo 0
    
    Dim Document As PartDocument
    Dim Part, SELECTION, Status, sSel
Dim InputObjectType(0)

On Error GoTo Ext
Set Document = MyCATIA.ActiveDocument
Set Part = Document.Part
Set SELECTION = Document.SELECTION

SELECTION.Clear

InputObjectType(0) = "AnyObject": iMsg = "Select anything to rename..."

MsgBox "PRESS OK AND SELECT ELEMENTS TO RENAME"

Status = SELECTION.SelectElement3(InputObjectType, iMsg, _
            False, CATMultiSelTriggWhenUserValidatesSelection, True)

If ((Status = "Cancel") Or (Status = "Undo") Or (Status = "Redo")) Then Exit Sub

Recall:
RenameOpt = InputBox("Rename with:" & Chr(13) & Chr(13) & _
                    "A) Prefix Only                  B) Number Only" & Chr(13) & Chr(13) & _
                    "C) Prefix and Number      D) Number and Suffix" & Chr(13) & Chr(13) & _
                    "E) Prefix and Number and Suffix" & Chr(13) & Chr(13) & _
                    "P.S: Type only A or B or C or D or E" & Chr(13))
                    
Dim iA As Boolean, iB As Boolean, iC As Boolean, iD As Boolean, iE As Boolean

If UCase(RenameOpt) = "A" Then
    iA = True
ElseIf UCase(RenameOpt) = "B" Then
    iB = True
ElseIf UCase(RenameOpt) = "C" Then
    iC = True
ElseIf UCase(RenameOpt) = "D" Then
    iD = True
ElseIf UCase(RenameOpt) = "E" Then
    iE = True
Else
    MsgBox "Invalid Option", vbCritical
    GoTo Recall
End If

If iA = True Or iC = True Or iE = True Then

iErrPre:
    iPrefix = InputBox("Prefix = ")
    If iPrefix = "" Then
        iCancelPre = MsgBox("No Prefix, Cancel the Macro...?", vbYesNo, "Warning")
    Else
        iCancelPre = vbNo
    End If
    If iCancelPre = vbNo Then
        If iPrefix = "" Then
            GoTo iErrPre
        End If
    Else
        SELECTION.Clear
        End
    End If

Else
    iPrefix = ""
    iCancelPre = vbNo
End If
    
If iB = True Or iC = True Or iD = True Or iE = True Then

    StartFrm = MsgBox("Start from 1...?", vbYesNo)
    If StartFrm = vbNo Then
IntAgain:
        iNumber = InputBox("Please give the number from to start...", , 0)
        If IsNumeric(iNumber) = False Then
            If iNumber = "" Then
                MsgBox "You entered nothing...", vbCritical
            Else
                MsgBox "iNumber" & " is not a valid number...", vbCritical
            End If
            GoTo IntAgain
        Else
            iCancelNu = vbNo
        End If
    Else
        iCancelNu = vbNo
        iNumber = 1
    End If
    
Else
    iNumber = ""
    iCancelNu = vbNo
End If

If iD = True Or iE = True Then
iErrSuf:
    iSuffix = InputBox("Suffix = ")
        If iSuffix = "" Then
        iCancelSuf = MsgBox("No Suffix, Cancel the Macro...?", vbYesNo, "Warning")
    Else
        iCancelSuf = vbNo
    End If
    If iCancelSuf = vbNo Then
        If iSuffix = "" Then
            GoTo iErrSuf
        End If
    Else
        SELECTION.Clear
        End
    End If

Else
    iSuffix = ""
    iCancelSuf = vbNo
End If

If iCancelPre = vbNo And iCancelNu = vbNo And iCancelSuf = vbNo Then

    For i = 1 To SELECTION.Count2
        Set ohybridbody = SELECTION.Item(i).Value
            On Error Resume Next
            ohybridbody.Name = iPrefix & iNumber & iSuffix
        iNumber = iNumber + 1
    Next i
    'MsgBox "All the selected elements are renamed."
    End

End If

SelectionNotValid:
    MsgBox "The Selection " & i & " is not valid to rename"
    End
    
Ext:
    MsgBox "Only CATPart is valid to run this Macro.", vbCritical
    End
       

End Sub
